//This is the main unit and is required.

uses DefinesUnit,ValveLogic,PumpLogic,TankLogic,IntegralLoop;

procedure Initialize;    //this is called once by the logic engine when
begin                    //simulator is started.
//set timer presets
 TMRS(dischargeValveOpenTimer,'PRE',40);    //4 seconds
 TMRS(dischargeValveCloseTimer,'PRE',40);   //4 seconds

 TMRS(tankValveOpenTimer,'PRE',40);         //4 seconds
 TMRS(tankValveCloseTimer,'PRE',40);        //4 seconds

 TMRS(tankLevelIncreaseTimer,'PRE',20);     //2 seconds
 TMRS(tankLevelDecreaseTimer,'PRE',20);     //2 seconds
 TMRS(tankFlowTimer,'PRE',10);              //1 second

//setup valves
 WV(openDischargeValveCommand,false);
 WV(closeDischargeValveCommand,false);

 WV(openTankValveCommand,false);
 WV(closeTankValveCommand,false);

 WV(dischargeValveClosed,true);
 WV(dischargeValveOpened,false);
 WV(tankValveClosed,true);
 WV(tankValveOpened,false);

 WVF(400005,0);        //loop SP
 WVF(400007,0);        //loop PV
 WVF(400013,0);        //loop OP

end;

procedure Main;
begin

 DoDischargeValve;
 DoTankValve;
 DoPumpLogic;
 DoTankLogic;
 IntegralSim;

end;
